#
# Conditional build:
%bcond_with	tests	# py.test tests [use network]
%bcond_without	python2 # CPython 2.x module
%bcond_with	python3 # CPython 3.x module

%define 	module	geventhttpclient
Summary:	A high performance, concurrent HTTP client library
Summary(pl.UTF-8):	Biblioteka bardzo wydajnego, wielowątkowego klienta HTTP
Name:		python-%{module}
# keep 1.x here for python2 support
Version:	1.5.5
Release:	4
License:	MIT
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/geventhttpclient/
Source0:	https://files.pythonhosted.org/packages/source/g/geventhttpclient/geventhttpclient-%{version}.tar.gz
# Source0-md5:	921c99dae79636616b4826423a870c9a
URL:		https://pypi.org/project/geventhttpclient/
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with python2}
# older versions generate pythonegg(backports.ssl_match_hostname) dependency
BuildRequires:	python-devel >= 1:2.7.9
BuildRequires:	python-modules >= 1:2.7.9
BuildRequires:	python-setuptools
%if %{with tests}
BuildRequires:	python-brotli
BuildRequires:	python-certifi
BuildRequires:	python-dpkt
BuildRequires:	python-gevent >= 0.13
BuildRequires:	python-pytest
BuildRequires:	python-six
%endif
%endif
%if %{with python3}
BuildRequires:	python3-devel >= 1:3.4
BuildRequires:	python3-modules >= 1:3.4
BuildRequires:	python3-setuptools
%if %{with tests}
BuildRequires:	python3-brotli
BuildRequires:	python3-certifi
BuildRequires:	python3-dpkt
BuildRequires:	python3-gevent >= 0.13
BuildRequires:	python3-pytest
BuildRequires:	python3-six
%endif
%endif
Requires:	python-modules >= 1:2.7.9
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
A high performance, concurrent HTTP client library for Python 2 using
gevent.

geventhttpclient use a fast HTTP parser, written in C, originating
from nginx, extracted and modified by Joyent.

geventhttpclient has been specifically designed for high concurrency,
streaming and support HTTP 1.1 persistent connections. More generally
it is designed for efficiently pulling from REST APIs and streaming
API's like Twitter's.

Safe SSL support is provided by default.

%description -l pl.UTF-8
Biblioteka bardzo wydajnego, wielowątkowego klienta HTTP dla Pythona
2, wykorzystująca gevent.

geventhttpclient wykorzystuje szybki parser HTTP, napisany w C,
pochodzący z serwera nginx, wyciągniety i zmodyfikowany przez Joyenta.

geventhttpclient został zaprojektowany w szczególności z myślą o
dużym zrównolegleniu, przesyłaniu strumieni i obsłudze trwałych
połączeń HTTP 1.1. Bardziej ogólnie, jest przeznaczony do wydajnego
pobierania z API REST-owych oraz strumieniowych, takich jak Twitter.

Domyślnie dostępna jest obsługa bezpiecznego SSL.

%package -n python3-%{module}
Summary:	A high performance, concurrent HTTP client library
Summary(pl.UTF-8):	Biblioteka bardzo wydajnego, wielowątkowego klienta HTTP
Group:		Libraries/Python
Requires:	python3-modules >= 1:3.4

%description -n python3-%{module}
A high performance, concurrent HTTP client library for Python 3 using
gevent.

geventhttpclient use a fast HTTP parser, written in C, originating
from nginx, extracted and modified by Joyent.

geventhttpclient has been specifically designed for high concurrency,
streaming and support HTTP 1.1 persistent connections. More generally
it is designed for efficiently pulling from REST APIs and streaming
API's like Twitter's.

Safe SSL support is provided by default.

%description -n python3-%{module} -l pl.UTF-8
Biblioteka bardzo wydajnego, wielowątkowego klienta HTTP dla Pythona
3, wykorzystująca gevent.

geventhttpclient wykorzystuje szybki parser HTTP, napisany w C,
pochodzący z serwera nginx, wyciągniety i zmodyfikowany przez Joyenta.

geventhttpclient został zaprojektowany w szczególności z myślą o
dużym zrównolegleniu, przesyłaniu strumieni i obsłudze trwałych
połączeń HTTP 1.1. Bardziej ogólnie, jest przeznaczony do wydajnego
pobierania z API REST-owych oraz strumieniowych, takich jak Twitter.

Domyślnie dostępna jest obsługa bezpiecznego SSL.

%prep
%setup -q -n %{module}-%{version}

%{__rm} -r src/geventhttpclient.egg-info

%build
%if %{with python2}
%py_build

%if %{with tests}
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTHONPATH=$(pwd)/$(echo build-2/lib.*) \
%{__python} -m pytest src
%endif
%endif

%if %{with python3}
%py3_build

%if %{with tests}
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTHONPATH=$(pwd)/$(echo build-3/lib.*) \
%{__python3} -m pytest src
%endif
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install

%py_postclean
%endif

%if %{with python3}
%py3_install
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc LICENSE.txt README.mdown
%dir %{py_sitedir}/geventhttpclient
%{py_sitedir}/geventhttpclient/*.py[co]
%attr(755,root,root) %{py_sitedir}/geventhttpclient/_parser.so
%{py_sitedir}/geventhttpclient-%{version}-py*.egg-info
%endif

%if %{with python3}
%files -n python3-%{module}
%defattr(644,root,root,755)
%doc LICENSE.txt README.mdown
%dir %{py3_sitedir}/geventhttpclient
%{py3_sitedir}/geventhttpclient/*.py
%{py3_sitedir}/geventhttpclient/__pycache__
%attr(755,root,root) %{py3_sitedir}/geventhttpclient/_parser.cpython-*.so
%{py3_sitedir}/geventhttpclient-%{version}-py*.egg-info
%endif
%changelog
* Sat Mar 15 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-geventhttpclient.git;a=log;h=master

* Sat Mar 15 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> 306b8f0
- Rel 4; disabled python3

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> a16f836
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 0297523
- python 3.13 rebuild

* Fri Sep 29 2023 Jakub Bogusz <qboosh@pld-linux.org> 2296654
- updated to 1.5.5

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> b9203fe
- rebuild with tests and docs

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 3c75be4
- Release 4 (by relup.sh)

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 8c48c91
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> c860555
- rebuild with python 3.10

* Thu Mar 24 2022 Jakub Bogusz <qboosh@pld-linux.org> ca83ee4
- updated to 1.5.3

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> c2732ab
- rebuild with separate debuginfo build-ids

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> 84e9660
- release 4 (by relup.sh)

* Mon Jan 06 2020 Jakub Bogusz <qboosh@pld-linux.org> d1cc782
- updated URLs

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> ea8f6c4
- rebuild with python 3.8
- release 3 (by relup.sh)

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> a8ca20b
- release 2 (by relup.sh)

* Thu Apr 27 2017 Jakub Bogusz <qboosh@pld-linux.org> 7b4d93c
- disable tests by default, they use network

* Thu Apr 27 2017 Jakub Bogusz <qboosh@pld-linux.org> 99278cd
- updated to 1.3.1
- pl, really run tests

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> 8c37b9f
- BR: rpmbuild(macros) >= 1.710

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 799dc14
- automatic change: use py_build/py_install macros

* Tue Nov 03 2015 Elan Ruusamäe <glen@delfi.ee> 64aabb6
- drop unneeded py3 copy

* Tue Nov 03 2015 Elan Ruusamäe <glen@delfi.ee> 7dc0e0a
- update BR

